///*
// * File:   zadani1.cpp
// * Author: Pavel Strnad
// *
// * Created on 7. listopad 2011, 18:59
// *
// * Implementujte chybejici funkce, tak aby sel kod prelozit. Zamerte se predevsim na to, aby
// * parametry, ktere jsou konstantni byly deklarovany jako const. 
// */
//
#include <stdlib.h>
#include <iostream>
#include <cstring> // for strlen(), strcpy()

using namespace std;

struct stringy {
    char * str; // ukazatel na retezce
    int ct; // delka retezce string (bez ukoncovaci ‘\0’)
};

void set(stringy& beany, const char* str) {
    beany.ct = strlen(str);
    beany.str = new char[beany.ct + 1];
    strcpy(beany.str, str);
}

void show(const char* str, unsigned times = 1) {
    for(unsigned i=0; i < times; ++i)
        cout << str << endl;
}

void show(const stringy& beany, unsigned times = 1) {
    show(beany.str, times);
}

int main() {
    stringy beany;
    char testing[] = "Reality isn’t what it used to be.";
    set(beany, testing); // first argument is a reference,
                         // allocates space to hold copy of testing,
                         // sets str member of beany to point to the
                         // new block, copies testing to new block,
                         // and sets ct member of beany
    show(beany); // vytiskne ulozeny retezec jednou
    show(beany, 2); // vytiskne ulozeny retezec dvakrat
    testing[0] = 'D'; 
    testing[1] = 'u';
    show(testing); // vytiskne testing retezec jednou
    show(testing, 3); // vytiskne testing retezec trikrat
    show("Done!");
    return 0;
}
